 /*
  * gfx.c - XBM blitting function
  * Copyright (c)2004 Pawel Szymczykowski <pawel@makenai.net>
  *
  *
  * This is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * It is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with Foobar; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

#include "gfx.h"

// putxbm : blits XBM data to the given surface at x_pos, y_pos.. this code is crap, but
// surely a dictionary doesn't need more speed than this?

void putxbm(GPDRAWSURFACE *surface, int x_pos, int y_pos, 
	unsigned char *bits, int width, int height, int color)
{
	int x, y, idxptr = 0;
	unsigned char mask = 1;

	for (y=0;y<height;y++) 
	{
		for (x=0;x<width;x++)
		{
			if (bits[idxptr] & mask) 
				GpPointSet(surface, x_pos + x, y_pos + y, color);
			if (!(mask<<=1)) { idxptr++; mask++; };
		}
		if (mask!=1) { idxptr++; mask=1; };
	}
}
