 /*
  * gpmain.c - GPNese Japanese <-> English Dictionary for GP32
  * Copyright (c)2004 Pawel Szymczykowski <pawel@makenai.net>
  *
  *
  * This is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
  * the Free Software Foundation; either version 2 of the License, or
  * (at your option) any later version.
  *
  * It is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU General Public License
  * along with Foobar; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  */

/* Stuff to do..
 * Would be nice if virtual keyboard was enabled before the dictionary actually finished loading.
 * Kanji dictionary with JUMP functionality
 */

#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpmem.h"
#include "gpnese.h"
#include "jconsole.h"
#include "jiten.h"
#include "cpuspeed.h"

#include "searchscreen.h"
#include "resultscreen.h"

#include "img/titlescreen.xbm"

#include "standins/KIJIS16.H"
#include "standins/RK8X16.H"

GPDRAWSURFACE gpDraw[2];
Jiten * dictionary;
BitFont * hankaku;
BitFont * zenkaku;
JConsole * console;
int currentSurface=0;
int mode = ETOJ;

void waitScreen();

void GpMain(void *arg)
{
	char term[255];
	int errornum;
	
	GpLcdSurfaceGet(&gpDraw[0], 0);  
	GpLcdSurfaceGet(&gpDraw[1], 1);  
	GpSurfaceSet(&gpDraw[currentSurface]);

	dictionary = new Jiten;
	hankaku = new BitFont(RK8X16, 8, 16);
	zenkaku = new BitFont(KIJIS16, 16, 16);
	console = new JConsole(13, 13, 297, 226, hankaku, zenkaku, 1000); 

	waitScreen();
	if ((errornum = dictionary->load("edictprv.dic", "edictprv.jdx")) != 0)
	{
		char message[80];
		gm_sprintf(message, "Error number %i", errornum);
		console->print(message);
		console->draw(&gpDraw[currentSurface]);
		while (1);
	}
	
	while (1)
	{
		
		searchScreen(term);
		resultScreen(term);
		term[0] = '\0';
	}
	GpAppExit();
}

void waitScreen()
{
	currentSurface = !currentSurface;
	putxbm(&gpDraw[currentSurface], 59, 76, titlescreen_bits, titlescreen_width, titlescreen_height, 0x00);
	GpSurfaceFlip(&gpDraw[currentSurface]);
}
